#ifndef __ANIMACAO_HPP__
#define __ANIMACAO_HPP__

#include "Face.hpp"

// Classe que manipula a animacao manual da face
// Os metodos de modificacao da face devem ser disparados aos poucos para
// permitir uma animacao suave
class Animacao
{
public:
   Animacao(Face *face);
   ~Animacao() {};

   // Inicia a animacao
   void iniciaAnimacao(double influencia);

   // Encerra a animacao
   void encerraAnimacao();

   // Verifica se a animacao encerrou
   bool encerrouAnimacao();

protected:
   // Face a ser animada
   Face* face;

   // Variavel que controla se a animacao deve ser disparada
   bool anima;

   // Influencia intermediaria da pose, incrementada ate o valor final
   double infAtual;

   // Variavel para controlar acoes que sao desfeitas apos ocorrerem
   // (exemplo: acao de piscar)
   bool desfaz;

   // Tempo para o inicio de uma proxima animacao
   int tempo;
};

#endif
