#ifndef __ANIMACAOPOSE_HPP__
#define __ANIMACAOPOSE_HPP__

#include "Animacao.hpp"

// Gerencia a animacao especifica do tipo Pose Animation, que modifica os 
// vertices da face
class AnimacaoPose : public Animacao
{
public:
   AnimacaoPose(Face* face) : 
      Animacao(face) {};
   ~AnimacaoPose() {};

   // Dispara uma unica pose, que sera um dos in-betweens no processo de 
   // interpolacao
   void atualizaPose(int pose, double infFinal);

   // Dispara a animacao incrementando a influencia aos poucos
   void interpola(int pose, double infFinal, double vel);
   void interpolaInverso(int pose, double infFinal, double vel);
   void interpolaDesfaz(int pose, double infFinal, double vel);

   // Sorteia o momento para disparar a proxima animacao involuntaria
   void sorteiaNovoTempo(int cntFrames, int tMin, int tDelta);
};

#endif
