#include "AnimacaoRotacao.hpp"

// Executa a acao de rotacionar a face em um dos tres eixos, dados a velocidade
// e o angulo de rotacao
void AnimacaoRotacao::rotaciona(char eixo, double limite, double vel)
{ 
   if (!encerrouAnimacao())
   {
      // Rotaciona aos poucos
      if (infAtual <= limite)
      {
         face->rotaciona(eixo, vel);
         infAtual++;
      }
      else
         encerraAnimacao();
   }
}

// Rotaciona e volta para a posicao inicial
void AnimacaoRotacao::rotacionaDesfaz(char eixo, double limite)
{
   if (!encerrouAnimacao())
   {
      // Ida: rotaciona
      if (!desfaz)
         rotaciona(eixo, limite, velRotacao);
      // Volta: rotaciona no sentido contrario (inverte o sinal da velocidade)
      else
         rotaciona(eixo, limite, -velRotacao);
      if (encerrouAnimacao())
      {
         desfaz = !desfaz;
         if (desfaz)
            iniciaAnimacao(0);
      }
   }
}

// O avatar deve rotacionar constantemente ao redor dos tres eixos. Ao final de
// uma rotacao, sorteia o valor da velocidade para a proxima rotacao
void AnimacaoRotacao::sorteiaNovaVelRotacao(double vel)
{
   // Uma nova rotacao ocorre ao final da anterior
   if (encerrouAnimacao())
   {
      iniciaAnimacao(0);
      srand(time(NULL));
      // A nova velocidade pode ser 0.01, -0.01 ou 0 (avatar fica imovel)
      velRotacao = ((rand() % 3) - 1) * vel;
   }
}

