#ifndef __AUDIO_HPP__
#define __AUDIO_HPP__

// Biblioteca de audio
#include "speak_lib.h"

#include "Ogre.h"
#include "OgreSingleton.h"

#include "Face.hpp"

using namespace Ogre;

// Classe que gerencia o audio do programa, presente na fala do avatar
class Audio : public Singleton<Audio>
{
public:
   Audio();
   ~Audio() {};
   
   // Metodos para a realizacao da fala
   void inicializaAudio();
   void defineVoz(Face* face);
   void pronuncia(const char* texto);
   void idParaString(unsigned int palavra);

   // Metodos para controle do estado da fala
   const char* fonemaAtual();
   void iniciaFala();
   void encerraFala();
   bool estaFalando();

private:
   // String relativa ao fonema que esta sendo falado no momento
   const char* fonema;

   // Variavel para marcar se o avatar esta falando
   bool fala;
};

#endif
