#ifndef __AVATOR_HPP__
#define __AVATOR_HPP__

#include <CEGUI/CEGUI.h>
#include <CEGUI/CEGUISchemeManager.h>
#include <CEGUI/CEGUIWindowManager.h>
#include <CEGUI/CEGUIImagesetManager.h>
#include <CEGUI/elements/CEGUIEditbox.h>
#include <CEGUI/elements/CEGUICombobox.h>

#include "OgreCEGUIRenderer.h"
#include "OgreStringConverter.h"

#include "FrameListenerAvator.hpp"
#include "AplicacaoBase.hpp"
#include "Face.hpp"
#include "Audio.hpp"

// Classe que controi a cena do programa
class Avator : public AplicacaoBase
{
public:
   Avator(bool usaCamera);
   ~Avator();

   // Cria os elementos da aplicacao
   void criaCamera();
   void criaLuz();
   void criaCena();
   void criaFrameListener();

private:
   // Face do avatar que sera usado
   Face* face;

   // Luz da cena
   Light* luz;

   // Objetos do CEGUI
   CEGUI::Editbox* caixaDeTexto;
   CEGUI::System* mSistemaGUI;
   CEGUI::OgreCEGUIRenderer* mRenderizadorGUI;

   // Metodos para a criacao e tratamento de widgets do programa
   void inicializaSistemaGUI();
   void inicializaCaixaDeTexto();
   void inicializaListaAvatares();
   bool trataMudancaAvatar(const CEGUI::EventArgs& e);
};

#endif
