#ifndef __FRAMELISTENERAVATOR_HPP__
#define __FRAMELISTENERAVATOR_HPP__

#include "Visao.hpp"
#include "FrameListenerCEGUI.hpp"
#include "MovimentacaoNaoVerbal.hpp"
#include "MovimentacaoOlhos.hpp"
#include "TratamentoFala.hpp"
#include "TratamentoExpressao.hpp"

// Classe que trata o fluxo do programa, recebendo os comandos da caixa de
// texto digitados pelo usuario e disparando todas as animacoes da face
class FrameListenerAvator : public FrameListenerCEGUI
{
public:
   FrameListenerAvator(RenderWindow* jan, Face* face, CEGUI::Editbox*
         caixaDeTexto, bool camera);
   ~FrameListenerAvator() {};

   // Especifica os eventos que acontecem no inicio e final de cada frame
   bool frameStarted(const FrameEvent &evt);
   bool frameEnded(const FrameEvent &evt);

   // Complementa metodo da superclasse para tratamento da entrada de teclado
   bool keyPressed(const OIS::KeyEvent &e);

private:
   // Face usada no programa
   Face* face;

   // Caixa de texto na qual o usuario digita suas perguntas
   CEGUI::Editbox* caixaDeTexto;

   // Manipulam as acoes da face ao longo do programa
   MovimentacaoNaoVerbal* idle;
   MovimentacaoOlhos* olhos;
   TratamentoFala* fala;
   TratamentoExpressao *expr;

   // Variavel que notifica quando o usuario interrompe o programa
   bool continueRenderizando;

   // Contador de frames. E preciso manter uma contagem dos frames para saber a
   // hora de disparar uma acao involuntaria
   int cntFrames;

   bool usaCamera;
};

#endif
