#ifndef __FRAMELISTENERBASE_HPP__
#define __FRAMELISTENERBASE_HPP__

#include "Ogre.h"
#include "OgreStringConverter.h"
#include "OgreException.h"

#define OIS_DYNAMIC_LIB
#include <OIS/OIS.h>

using namespace Ogre;

// Inicializa um frame listener para o programa, que recebera os eventos de
// mouse e teclado, utilizando a biblioteca OIS, de gerenciamento de entrada
// Baseada na implementacao do arquivo ExampleFrameListener, do Ogre
class FrameListenerBase: public FrameListener, public WindowEventListener
{
public:
   // O frame listener determina o contexto da entrada a partir da janela da
   // aplicacao
   FrameListenerBase(RenderWindow* jan, bool bufferedKeys, bool bufferedMouse);
   ~FrameListenerBase();

   virtual void redimensiona(RenderWindow* janela);
   virtual void encerra(RenderWindow* janela);

protected:
   RenderWindow* janela;

   // Gerenciador de entrada do OIS
   OIS::InputManager* inputMgr;

   // Dispositivos de entrada do OIS
   OIS::Mouse* mouse;
   OIS::Keyboard* teclado;
};

#endif
