#ifndef __FRAMELISTENERCEGUI_HPP__
#define __FRAMELISTENERCEGUI_HPP__

#include <CEGUI/CEGUISchemeManager.h>
#include <CEGUI/CEGUIWindowManager.h>
#include <CEGUI/CEGUIImagesetManager.h>
#include <CEGUI/elements/CEGUIEditbox.h>
#include "OgreCEGUIRenderer.h"

#include "FrameListenerBase.hpp"

// A biblioteca CEGUI e uma biblioteca de interface grafica usada para criacao
// de widgets como menus, caixas de texto etc.
// Classe que interpreta os eventos de mouse e teclado relativos aos objetos do
// CEGUI presentes no programa
class FrameListenerCEGUI : public FrameListenerBase, public OIS::KeyListener, 
   public OIS::MouseListener
{
public:
   FrameListenerCEGUI(RenderWindow* jan);
   ~FrameListenerCEGUI() {};

   // Especifica os eventos que acontecem no inicio e final de cada frame
   bool frameStarted(const FrameEvent &evt);
   bool frameEnded(const FrameEvent &evt);
   
   // Receptores do mouse
   bool mouseMoved(const OIS::MouseEvent &e);
   bool mousePressed(const OIS::MouseEvent &e, OIS::MouseButtonID id);
   bool mouseReleased(const OIS::MouseEvent &e, OIS::MouseButtonID id);

   // Receptores do teclado
   bool keyPressed(const OIS::KeyEvent &e);
   bool keyReleased(const OIS::KeyEvent &e);

private:
   // Converte o botao do mouse do OIS para um botao do CEGUI
   CEGUI::MouseButton convertOISButtonToCegui(int buttonID);
};

#endif
