#include "Modelo.hpp"

// Construtor
Modelo::Modelo(String arquivo)
{
   arquivoMalha = arquivo;
}

// Cria a entidade a partir do arquivo da malha
void Modelo::criaEntidade(SceneManager* sceneMgr)
{
   entidade = sceneMgr->createEntity(arquivoMalha, arquivoMalha);
}

// Anexa a entidade a um no da cena
void Modelo::anexaEntidade(SceneNode* no)
{
   entidade->setVisible(true);
   no->attachObject(entidade);
}

// Remove a entidade de um no da cena
void Modelo::removeEntidade(SceneManager* sceneMgr, SceneNode* no)
{
   entidade->setVisible(false);
   no->detachObject(entidade->getName());
   sceneMgr->destroyEntity(arquivoMalha);
}

Entity* Modelo::getEntidade()
{
   return entidade;
}

void Modelo::setEntidade(Entity* ent)
{
   entidade = ent;
}

