#ifndef __MODELO_HPP__
#define __MODELO_HPP__

#include "Ogre.h"

using namespace Ogre;

// Classe que representa um modelo tridimensional
// No programa, a face possui 8 modelos (submalhas) que a compoem
class Modelo
{
public:
   Modelo(String arquivoMalha);
   ~Modelo() {};

   // Operacoes sobre a entidade
   void criaEntidade(SceneManager* sceneMgr);
   void anexaEntidade(SceneNode* no);
   void removeEntidade(SceneManager* sceneMgr, SceneNode* no);

   Entity* getEntidade();
   void setEntidade(Entity* ent);
      
protected:   
   // O modelo e caracterizado por uma malha carregada a partir de um arquivo 
   // mesh
   String arquivoMalha;

   // A entidade e o objeto que e representado pelo arquivo, podendo ser
   // anexada a cena
   Entity* entidade;
};

#endif
