#ifndef __MODELOFACE_HPP__
#define __MODELOFACE_HPP__

#include "ModeloAnimado.hpp"

// Classe que representa o modelo tridimensional da face, encapsulando todos os
// modelos que a compoem
class ModeloFace
{
public:
   ModeloFace() {};
   ~ModeloFace() {};
   
   // Metodos que reunem a configuracao inicial dos modelos que compoem a face
   void carregaComponentesFace();

   void criaAnimacoesFace();
   void inicializaAnimacoesFace();
   void removeAnimacoesFace();

   void criaEntidadesFace(SceneManager* sceneMgr);
   void recebeComponentesFace(SceneManager* sceneMgr);
   void inicializaFace(SceneManager* sceneMgr);
   
   // Metodos sobre o no da cena ao qual a face pertence
   void criaNoFace(SceneManager* sceneMgr, Vector3 posicao);
   void anexaFaceCena();
   void removeFaceCena(SceneManager* sceneMgr);
   void rotaciona(char eixo, double angulo);

   void setNome(String nome);
   String getNome();

protected:
   // Cada uma das partes integrantes da face
   ModeloAnimado* olhoEsquerdo;
   ModeloAnimado* olhoDireito;
   ModeloAnimado* pele;
   ModeloAnimado* denteBaixo;
   ModeloAnimado* denteCima;
   ModeloAnimado* lingua;
   ModeloAnimado* interiorBoca;
   Modelo* cabelo;
      
   // Todos os componentes sao reunidos em um unico no, o no da face, atraves
   // do qual todas as modificacoes de rotacao, translacao e escala aplicados
   // na face sao repassados para todos os componentes
   SceneNode* noFace;

   // Nome que caracteriza o avatar
   String nomeAvatar;
};

#endif
