#ifndef __MovimentacaoNaoVerbal_HPP__
#define __MovimentacaoNaoVerbal_HPP__

#include "TratamentoExpressao.hpp"
#include "AnimacaoRotacao.hpp"
#include "AnimacaoPose.hpp"

// Angulos de rotacao do avatar
#define ANGULOX 300
#define ANGULOY 400
#define ANGULOZ 200

// Velocidades de rotacao do avatar
#define VELX 0.01
#define VELY 0.01
#define VELZ 0.01

// Numero de acoes
#define NUM_ACOES 4
#define NUM_ROTACOES 3

// Classe que trata as animacoes involuntarias do avatar:
// -- Acoes nao verbais (piscar, levantar as sobrancelhas, apertar os olhos e 
// levantar os cantos da boca)
// -- Rotacao nos eixos x, y e z
class MovimentacaoNaoVerbal
{
public:
   MovimentacaoNaoVerbal(Face* face);
   ~MovimentacaoNaoVerbal() {};

   // Animacoes manuais disparadas ao longo do programa
   void trataAcaoInvoluntaria(int cntFrames);
   void trataRotacaoInvoluntaria();

private:
   Face* face;

   // Animacao de movimentos nao verbais
   AnimacaoPose* animAcao[NUM_ACOES];

   // Animacao de rotacao ao redor dos eixos x, y e z
   AnimacaoRotacao* animRotacao[NUM_ROTACOES];

   // A influencia da acao de piscar e variavel
   double infPisca;
};

#endif
