#ifndef __SincronizacaoLabial_HPP__
#define __SincronizacaoLabial_HPP__

#include <string.h>
#include <iostream>
#include <map>
#include <utility>
#include "AnimacaoPose.hpp"
#include "Audio.hpp"

using namespace std;

// Classe que sincroniza o fonema falado no momento com o movimento da boca da
// face (visema)
class SincronizacaoLabial
{
public:
   SincronizacaoLabial();
   ~SincronizacaoLabial();

   // Efetua o mapeamento, disparando a animacao correspondente
   void sincroniza(AnimacaoPose* animacao[]);

private:
   // Fonemas sao mapeados para grupos de visemas e armazenados numa tabela.
   // Esta tabela foi implementada utilizando o objeto multimap da biblioteca
   // STL, do C++
   multimap<int, char> tabela;
   
   // Armazena o fonema anterior da fala
   char fonemaAnterior;

   // Preenche a tabela, definindo os mapeamentos que devem ser feitos
   void montaTabelaVisemas();
};

#endif
