#ifndef __TratamentoExpressao_HPP__
#define __TratamentoExpressao_HPP__

#include "Audio.hpp"
#include "AnimacaoPose.hpp"

// Influencia das expressoes faciais
#define INF_EXPR 0.7

// Velocidade com que a face muda de TratamentoExpressao
#define VEL_EXPR 0.01

// Classe que manipula as trocas de expressao facial ao longo do programa
class TratamentoExpressao
{
public:
   TratamentoExpressao(Face* face);
   ~TratamentoExpressao() {};

   // Trata as animacoes de mudanca de espressao facial
   void trataMudancaExpressao();

   // Dispara estas animacoes, que podem ocorrer no inicio e no final de uma
   // frase falada pelo avatar
   void mudaExpressaoInicio(int acao, bool desfaz);
   void mudaExpressaoFim(int acao, bool desfaz);

   void zeraVetorExpressoes();

private:
   Face* face;

   // Animacoes para a troca de expressao facial que pode ocorrer no inicio ou
   // no final da fala
   AnimacaoPose* animIni[NUM_EXPR];
   AnimacaoPose* animFim[NUM_EXPR];

   // As expressoes podem ser feitas ou desfeitas (valor < 0). O vetor expr
   // armazena a informacao se a face deve ser feita ou desfeita
   int exprIni[NUM_EXPR];
   int exprFim[NUM_EXPR];
};

#endif

