#ifndef __TratamentoFala_HPP__
#define __TratamentoFala_HPP__

#include "Audio.hpp"
#include "AnimacaoPose.hpp"
#include "SincronizacaoLabial.hpp"
#include "TratamentoExpressao.hpp"

// Influencia dos visemas
#define INF_VIS 0.7

// Velocidade com que a face muda de visema
#define VEL_VIS 0.03

// Tamanho maximo do texto da entrada
#define MAXCHAR 200

// Classe que trata a pronuncia de uma frase, utilizando o objeto de 
// sincronizacao para disparar os visemas corretos
class TratamentoFala
{
public:
   TratamentoFala(Face* face);
   ~TratamentoFala() {};

   // Processamento da fala
   void reproduzFala(String frase);

   // Dispara a mudanca de visemas ao longo da fala
   void trataMudancaVisema();

   // Processa uma frase, retirando marcadores de expressao e pronunciando o
   // restante
   String processaEntrada(String frase, TratamentoExpressao* expr);
   
private:
   // Animacao para os visemas
   AnimacaoPose* animVisemas[NUM_VIS];

   // Objeto que cuida da sincronizacao labial
   SincronizacaoLabial* labios;
};

#endif

