/* 
 * =======================================================================
 *             MAC 499 - Trabalho de Formatura Supervisionado
 *       Sistema de Animação Facial Tridimensional e Síntese de Voz
 *       
 *       Aluna: Andréa Britto Mattos
 *       Orientador: Roberto Marcondes Cesar Jr.
 * =======================================================================
 */

#include "Avator.hpp"

#if OGRE_PLATFORM == OGRE_PLATFORM_WIN32
#define WIN32_LEAN_AND_MEAN
#include "windows.h"
#endif

#ifdef __cplusplus
extern "C" {
#endif

int main(int argc, char *argv[])
{
   // Por padrao a camera  esta habilitada
   bool usaCamera = true;

   // Ajuda
   if (argc == 2)
   {
      if (strcmp(argv[1], "-help") == 0)
      {
         printf("Por padrao, utiliza camera. Para desabilita-la,\n");
         printf("utilize o parametro -camera=false\n");
         return 0;
      }
   
      // Verifica se esta sendo passado o parametro para desabilitar a camera
      else if (strcmp(argv[1], "-camera=false") == 0)
         usaCamera = false;
      else if (strcmp(argv[1], "-camera=true") == 0);
      else
      {
         printf("Parametro invalido! Use ./Avator -help para ajuda.\n");
         return -1;
      }
   }

   // Cria o objeto da aplicacao
   Avator av(usaCamera);

   // Roda o programa
   try
   {
      av.configura();
      av.inicia();
   } catch(Exception& e)
   {
#if OGRE_PLATFORM == PLATFORM_WIN32 || OGRE_PLATFORM == OGRE_PLATFORM_WIN32
      MessageBox(NULL, e.getFullDescription().c_str(), "ERRO!", MB_OK | 
            MB_ICONERROR | MB_TASKMODAL);
#else
      fprintf(stderr, "ERRO: %s\n",
            e.getFullDescription().c_str());
#endif
   }
   return 0;
}

#ifdef __cplusplus
}
#endif


